/* SPDX-FileCopyrightText: © 2022 Decompollaborate */
/* SPDX-License-Identifier: MIT */

#ifndef RABBITIZER_OPERAND_TYPE_H
#define RABBITIZER_OPERAND_TYPE_H
#pragma once


typedef enum RabbitizerOperandType {
    RABBITIZER_OPERAND_TYPE_INVALID,
    RABBITIZER_OPERAND_TYPE_rs,
    RABBITIZER_OPERAND_TYPE_rt,
    RABBITIZER_OPERAND_TYPE_rd,
    RABBITIZER_OPERAND_TYPE_cop0d,
    RABBITIZER_OPERAND_TYPE_fs,
    RABBITIZER_OPERAND_TYPE_ft,
    RABBITIZER_OPERAND_TYPE_fd,
    RABBITIZER_OPERAND_TYPE_cop1cs, // Coprocessor 1 control fs
    RABBITIZER_OPERAND_TYPE_cop2t,
    RABBITIZER_OPERAND_TYPE_sa,
    RABBITIZER_OPERAND_TYPE_op,
    RABBITIZER_OPERAND_TYPE_code,
    RABBITIZER_OPERAND_TYPE_LABEL,
    RABBITIZER_OPERAND_TYPE_IMM,
    RABBITIZER_OPERAND_TYPE_IMM_base,

    // rsp
    RABBITIZER_OPERAND_TYPE_RSP_rs,
    RABBITIZER_OPERAND_TYPE_RSP_rt,
    RABBITIZER_OPERAND_TYPE_RSP_rd,
    RABBITIZER_OPERAND_TYPE_RSP_cop0d,
    RABBITIZER_OPERAND_TYPE_RSP_vs,
    RABBITIZER_OPERAND_TYPE_RSP_vt,
    RABBITIZER_OPERAND_TYPE_RSP_vd,
    RABBITIZER_OPERAND_TYPE_RSP_vt_elementhigh,
    RABBITIZER_OPERAND_TYPE_RSP_vt_elementlow,
    RABBITIZER_OPERAND_TYPE_RSP_vd_vs,
    RABBITIZER_OPERAND_TYPE_RSP_vd_index,
    RABBITIZER_OPERAND_TYPE_RSP_offset_rs,
    // rsp

    RABBITIZER_OPERAND_TYPE_MAX,
} RabbitizerOperandType;

#endif
